/*
  Generic lexical scanning functions to be used by any scanner.
  This file is included into other scanner source files
*/
/*
 * For licensing terms, see the file COPYING
 * For contact information, see the file AUTHORS
 *
 */

/* TODO: Remove this artifact from when the scanning functions were used 
 * for both xml and the rc file. Now, all xml work is handled by expat*/


#include <stdlib.h>
#ifdef SCAN_CONFIG
#define SCANNER CONFIG_SCANNER
#endif

#ifdef SCAN_XML
#define SCANNER XML_SCANNER

#endif


#if (defined(SCAN_CONFIG)||defined(SCAN_XML))
static void nextchar(SCANNER *scanner)
{
	/*assert(scanner->count<=TOKEN_SIZE);*/
	if (scanner->count>=scanner->capacity-1) 
	{
		/*scanner->ahead=*(++scanner->code);
		return;*/
		scanner->capacity=expand_str(&(scanner->token));
		if (scanner->capacity<0)
		{
			printf("unable to allocate memory\n");
			exit(0);
		}
	}
	
	scanner->token[scanner->count++]=scanner->ahead;
	scanner->colcount++;
	scanner->ahead=*(++scanner->code);
}
static int iswhitespace(SCANNER *scanner,char d)
{
	if ((d==13)||(d==10))scanner->linecount++,scanner->colcount=0;
	return ( (d==' ')||(d==9)||(d==13)||(d==10));
}

static void eatwhitespace(SCANNER *scanner)
{
	scanner->ahead=*(++scanner->code);
	while(iswhitespace(scanner,scanner->ahead))
		scanner->ahead=*(++scanner->code);
}

#else
#error Scanner type not defined (XML,CONFIG)
#endif
